
package BK::Books;

use Moose;
use utf8;

# Table to translate name of the book to abbrev. (id),
# for example: 'Genesis' to 'Gn'
# See fnd_book_id().

has b_ids => (
  is => 'bare',
  isa => 'ArrayRef[ArrayRef]',
  traits => ['Array'],
  default => sub { [
   # the Old Testament
    [ 'Gn' => qr/genesis/ ] ,
    [ 'Ex' => qr/exodus/ ] ,
    [ 'Lv' => qr/leviticus/ ] ,
    [ 'Nu' => qr/numeri/ ] ,
    [ 'Dt' => qr/deuteronomium/ ] ,
    [ 'Joz' => qr/jozue/ ] ,
    [ 'Sd' => qr/soudc[uů]/ ] ,
    [ 'Rt' => qr/r[úu]t/ ] ,
    [ '2S' => qr/^(?:2|druhá|ii_).*samuelova/ ] ,
    [ '1S' => qr/^(?:1|první|i_).*samuelova/ ] ,
    [ '2Kr' => qr/^(?:2|druhá|ii_).*královská/ ] ,
    [ '1Kr' => qr/^(?:1|první|i_).*královská/ ] ,
    [ '2Pa' => qr/^(?:2|druhá|ii_).*paralipomenon/ ] ,
    [ '1Pa' => qr/^(?:1|první|i_).*paralipomenon/ ] ,
    [ 'Ezd' => qr/ezdráš/ ] ,
    [ 'Neh' => qr/nehemij?áš/ ] ,
    [ 'Est' => qr/ester/ ] ,
    [ 'Jb' => qr/j[óo]b/ ] ,
    [ 'Z' => qr/žalm/ ] ,
    [ 'Pr' => qr/přísloví/ ] ,
    [ 'Kaz' => qr/kazatel/ ] ,
    [ 'Pis' => qr/píseň.(?:písní|šal[oa]m)/ ] ,
    [ 'Iz' => qr/iza(?:i|j)áš/ ] ,
    [ 'Pl' => qr/pláč/ ] ,
    [ 'Jr' => qr/^jere?mij?áš/ ] ,
    [ 'Ez' => qr/ezechiel/ ] ,
    [ 'Da' => qr/daniel/ ] ,
    [ 'Oz' => qr/ozeáš/ ] ,
    [ 'Jl' => qr/j(?:ó|o)el/ ] ,
    [ 'Am' => qr/[aá]mos/ ] ,
    [ 'Abd' => qr/abdij?áš/ ] ,
    [ 'Jon' => qr/jonáš/ ] ,
    [ 'Mi' => qr/micheáš/ ] ,
    [ 'Na' => qr/nahum/ ] ,
    [ 'Abk' => qr/abakuk/ ] ,
    [ 'Sf' => qr/sofon(?:i|j)áš/ ] ,
    [ 'Ag' => qr/ag(?:gea|geus|eus)/ ] ,
    [ 'Za' => qr/zachar(?:iá|já)š/ ] ,
    [ 'Mal' => qr/malachiáš/ ] ,
   # the New Testament
    [ 'Mt' => qr/matou[šs]/ ] ,
    [ 'Mk' => qr/mar(?:ka|ek)/ ] ,
    [ 'L' => qr/lukáš|lukas/ ] ,
    [ 'Sk' => qr/skutk(?:y|ové)/ ] ,
    [ 'R'  => qr/římanům|rimanum/ ] ,
    [ '2K'  => qr/^(?:2|druhá|ii_).*korintsk/ ] ,
    [ '1K'  => qr/^(?:1|první|i_).*korintsk/ ] ,
    [ 'Ga'  => qr/galatsk/ ] ,
    [ 'Ef'  => qr/efezsk/ ] ,
    [ 'Fp'  => qr/filip(?:en)?sk[yý]m/ ] ,
    [ 'Ko'  => qr/kolos(?:sens)k[yý]m/ ] ,
    [ '2Te' => qr/^(?:2|druhá|ii_).*tess?alonice?/ ] ,
    [ '1Te' => qr/^(?:1|první|i_).*tess?alonice?/ ] ,
    [ '2Tm' => qr/^(?:2|druhá|ii_).*timoteovi/ ] ,
    [ '1Tm' => qr/^(?:1|první|i_).*timoteovi/ ] ,
    [ 'Tt'  => qr/titovi/ ] ,
    [ 'Fm'  => qr/filemonovi/ ] ,
    [ 'Zd'  => qr/židům|zidum/ ] ,
    [ 'Jk'  => qr/jakub/ ] ,
    [ '2Pt' => qr/^(?:2|druhá|ii_).*petr/ ] ,
    [ '1Pt' => qr/^(?:1|první|i_).*petr/ ] ,
    [ '3J'  => qr/^(?:3|třetí|iii_).*jan/ ] ,
    [ '2J'  => qr/^(?:2|druhá|ii_).*jan/ ] ,
    [ '1J'  => qr/^(?:1|první|i_).*jan/ ] ,
    [ 'Ju'  => qr/jud(?:ův|y|a|ova)/ ] ,
    [ 'Zj'  => qr/zjeven/ ] ,
    [ 'J'  => qr/^jan/ ] ,
   ]
  },
  handles => {
    all_books => 'elements',
    book_count => 'count',
  },
);

sub fnd_book_id {

  my ( $self, $book ) = @_;
  my $book_lc = lc $book;

  my $id;
  for my $i ( $self->all_book ) {
    if ( $book_lc =~ /$i->[1]/ ) {
      warn "Not uniq Id found: $book: $id: $i->[0]" if $id and $id ne $i->[0];
      $id = $i->[0];
    }
  }
  return $id;
}

# Old Testament - ordered list of books
has old_t => (
  is => 'bare',
  isa => 'ArrayRef[Str]',
  traits => ['Array'],
  default => sub { [
   'Gn' ,
   'Ex' ,
   'Lv' ,
   'Nu' ,
   'Dt' ,
   'Joz' ,
   'Sd' ,
   'Rt' ,
   '1S' ,
   '2S' ,
   '1Kr' ,
   '2Kr' ,
   '1Pa' ,
   '2Pa' ,
   'Ezd' ,
   'Neh' ,
   'Est' ,
   'Jb' ,
   'Z' ,
   'Pr' ,
   'Kaz' ,
   'Pis' ,
   'Iz' ,
   'Jr' ,
   'Pl' ,
   'Ez' ,
   'Da' ,
   'Oz' ,
   'Jl' ,
   'Am' ,
   'Abd' ,
   'Jon' ,
   'Mi' ,
   'Na' ,
   'Abk' ,
   'Sf' ,
   'Ag' ,
   'Za' ,
   'Mal' ] },
  handles => {
    ot_all_books => 'elements',
    ot_book_count => 'count',
  },
);

# New Testament - ordered list of books
has new_t => (
  is => 'bare',
  isa => 'ArrayRef[Str]',
  traits => ['Array'],
  default => sub { [
   'Mt' ,
   'Mk' ,
   'L' ,
   'J' ,
   'Sk' ,
   'R' ,
   '1K' ,
   '2K' ,
   'Ga' ,
   'Ef' ,
   'Fp' ,
   'Ko' ,
   '1Te' ,
   '2Te' ,
   '1Tm' ,
   '2Tm' ,
   'Tt' ,
   'Fm' ,
   'Zd' ,
   'Jk' ,
   '1Pt' ,
   '2Pt' ,
   '1J' ,
   '2J' ,
   '3J' ,
   'Ju' ,
   'Zj' , ] },
  handles => {
    nt_all_books => 'elements',
    nt_book_count => 'count',
  },
 );

# count of chapters per a book
has chaps_per_book => (
  is => 'bare',
  isa => 'HashRef[Int]',
  traits => ['Hash'],
  default => sub { {
    Gn => 50 ,
    Ex => 40 ,
    Lv => 27 ,
    Nu => 36 ,
    Dt => 34 ,
    Joz => 24 ,
    Sd => 21 ,
    Rt => 4 ,
    "1S" => 31 ,
    "2S" => 24 ,
    "1Kr" => 22 ,
    "2Kr" => 25 ,
    "1Pa" => 29 ,
    "2Pa" => 36 ,
    Ezd => 10 ,
    Neh => 13 ,
    Est => 10 ,
    Jb => 42 ,
    Z => 150 ,
    Pr => 31 ,
    Kaz => 12 ,
    Pis => 8 ,
    Iz => 66 ,
    Jr => 52 ,
    Pl => 5 ,
    Ez => 48 ,
    Da => 12 ,
    Oz => 14 ,
    Jl => 3 ,
    Am => 9 ,
    Abd => 1 ,
    Jon => 4 ,
    Mi => 7 ,
    Na => 3 ,
    Abk => 3 ,
    Sf => 3 ,
    Ag => 2 ,
    Za => 14 ,
    Mal => 4 ,
    #---------- ,
    Mt => 28 ,
    Mk => 16 ,
    L => 24 ,
    J => 21 ,
    Sk => 28 ,
    R => 16 ,
    "1K" => 16 ,
    "2K" => 13 ,
    Ga => 6 ,
    Ef => 6 ,
    Fp => 4 ,
    Ko => 4 ,
    "1Te" => 5 ,
    "2Te" => 3 ,
    "1Tm" => 6 ,
    "2Tm" => 4 ,
    Tt => 3 ,
    Fm => 1 ,
    Zd => 13 ,
    Jk => 5 ,
    "1Pt" => 5 ,
    "2Pt" => 3 ,
    "1J" => 5 ,
    "2J" => 1 ,
    "3J" => 1 ,
    Ju => 1 ,
    Zj => 22 , } },
  handles => {
    get_ch_count => 'get',
    b_ch_pairs   => 'kv',
    b_exists => 'exists',
    # has_no_options => 'is_empty',
    # num_options  => 'count',
  },
);

__PACKAGE__->meta->make_immutable;

no Moose;

1;
